| Flutter Impeller |

Public Member Functions | List of all members
impeller::EllipseGeometry Class Referencefinal

A Geometry class that can directly generate vertices (with or without texture coordinates) for filled ellipses. More...

`#include <ellipse_geometry.h>`

Inheritance diagram for impeller::EllipseGeometry:

## Public Member Functions
| EllipseGeometry (Rect bounds)
| ~EllipseGeometry () override=default
bool | CoversArea (const Matrix &transform, const Rect &rect) const override
| Determines if this geometry, transformed by the given `transform`, will completely cover all surface area of the given `rect`. More...
bool | IsAxisAlignedRect () const override
Public Member Functions inherited from impeller::Geometry
virtual | ~Geometry ()
virtual GeometryResult::Mode | GetResultMode () const
virtual bool | CanApplyMaskFilter () const
virtual Scalar | ComputeAlphaCoverage (const Matrix &transform) const

## Additional Inherited Members
Static Public Member Functions inherited from impeller::Geometry
static std::unique_ptr< Geometry > | MakeFillPath (const flutter::DlPath &path, std::optional< Rect > inner_rect=std::nullopt)
static std::unique_ptr< Geometry > | MakeStrokePath (const flutter::DlPath &path, const StrokeParameters &stroke={})
static std::unique_ptr< Geometry > | MakeCover ()
static std::unique_ptr< Geometry > | MakeRect (const Rect &rect)
static std::unique_ptr< Geometry > | MakeOval (const Rect &rect)
static std::unique_ptr< Geometry > | MakeLine (const Point &p0, const Point &p1, const StrokeParameters &stroke)
static std::unique_ptr< Geometry > | MakeCircle (const Point &center, Scalar radius)
static std::unique_ptr< Geometry > | MakeStrokedCircle (const Point &center, Scalar radius, Scalar stroke_width)
static std::unique_ptr< Geometry > | MakeFilledArc (const Rect &oval_bounds, Degrees start, Degrees sweep, bool include_center)
static std::unique_ptr< Geometry > | MakeStrokedArc (const Rect &oval_bounds, Degrees start, Degrees sweep, const StrokeParameters &stroke)
static std::unique_ptr< Geometry > | MakeRoundRect (const Rect &rect, const Size &radii)
static std::unique_ptr< Geometry > | MakeRoundSuperellipse (const Rect &rect, Scalar corner_radius)
static Scalar | ComputeStrokeAlphaCoverage (const Matrix &entity, Scalar stroke_width)
| Compute an alpha value to simulate lower coverage of fractional pixel strokes. More...
static GeometryResult | ComputePositionGeometry (const ContentContext &renderer, const Tessellator::VertexGenerator &generator, const Entity &entity, RenderPass &pass)

## Detailed Description

A Geometry class that can directly generate vertices (with or without texture coordinates) for filled ellipses.

Generating vertices for a stroked ellipse would require a lot more work since the line width must be applied perpendicular to the distorted ellipse shape.

See also
  |StrokeEllipseGeometry|

Definition at line 21 of file ellipse_geometry.h.

## Constructor & Destructor Documentation

## ◆ EllipseGeometry()

impeller::EllipseGeometry::EllipseGeometry | ( | Rect | bounds | ) |
| explicit

Definition at line 13 of file ellipse_geometry.cc.

13 : bounds_(bounds) {}

## ◆ ~EllipseGeometry()

impeller::EllipseGeometry::~EllipseGeometry | ( |  | ) |
| overridedefault

## Member Function Documentation

## ◆ CoversArea()

bool impeller::EllipseGeometry::CoversArea | ( | const Matrix & | transform,
|  | const Rect & | rect
| ) |  | const
| overridevirtual

Determines if this geometry, transformed by the given `transform`, will completely cover all surface area of the given `rect`.

This is a conservative estimate useful for certain optimizations.

Returns
  `true` if the transformed geometry is guaranteed to cover the given `rect`. May return `false` in many undetected cases where the transformed geometry does in fact cover the `rect`.

Reimplemented from impeller::Geometry.

Definition at line 30 of file ellipse_geometry.cc.

31 {
32 return false;
33 }

## ◆ IsAxisAlignedRect()

bool impeller::EllipseGeometry::IsAxisAlignedRect | ( |  | ) | const
| overridevirtual

Reimplemented from impeller::Geometry.

Definition at line 35 of file ellipse_geometry.cc.

35 {
36 return false;
37 }

The documentation for this class was generated from the following files:

- impeller/entity/geometry/ellipse_geometry.h
- impeller/entity/geometry/ellipse_geometry.cc